# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.
---

task-defaults:
    always-target: true
    attributes:
        build_platform: android
        build_type: opt
        code-review: true
    description: Android lints
    platform: lint/opt
    treeherder:
        kind: test
        tier: 1
    worker-type: t-linux-docker-amd
    worker:
        docker-image: {in-tree: android-build}
        env:
            GRADLE_USER_HOME: /builds/worker/checkouts/gecko/mobile/android/gradle/dotgradle-offline
            MOZCONFIG: mobile/android/config/mozconfigs/android-arm/nightly-android-lints
            MOZ_OBJDIR: obj-firefox
            PERFHERDER_EXTRA_OPTIONS: android-lints
            TINDERBOX_OUTPUT: '1'
        max-run-time: 3600
        artifacts:
            - type: file
              name: public/code-review/mozlint.json
              path: /builds/worker/mozlint.json
            - name: public/android/geckoview/api.txt
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/mobile/android/geckoview/intermediates/javac/debug/api.txt
              type: file
            - name: public/android/geckoview/api.txt.map
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/mobile/android/geckoview/intermediates/javac/debug/api.txt.map
              type: file
            - name: public/android/geckoview/apilint-result.json
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/mobile/android/geckoview/intermediates/javac/debug/apilint-result.json
              type: file
            - name: public/android/geckoview/javadoc-results.json
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/mobile/android/geckoview/reports/javadoc-results-debug.json
              type: file
            - name: public/geckoview/unittest
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/mobile/android/geckoview/reports/tests
              type: directory
            - name: public/android/lint/lint-results-debug.xml
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/mobile/android/geckoview/reports/lint-results-debug.xml
              type: file
            - name: public/android/checkstyle/checkstyle.html
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/mobile/android/geckoview/reports/checkstyle/debug.html
              type: file
            - name: public/android/checkstyle/checkstyle.xml
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/mobile/android/geckoview/reports/checkstyle/debug.xml
              type: file
            - name: public/reports
              path: /builds/worker/checkouts/gecko/obj-firefox/gradle/build/reports
              type: directory
    run-on-repo-type: [hg]
    run:
        using: run-task
        tooltool-downloads: internal  # For internal toolchains.
    fetches:
        toolchain:
            # Aliases aren't allowed for toolchains installed by fetch.
            - linux64-android-gradle-dependencies
            - linux64-android-sdk-linux-repack
            - linux64-jdk-repack
            - linux64-node


lints:
    treeherder:
        symbol: A(lints)
    run:
        command: >
            ln -s $MOZ_FETCHES_DIR/android-gradle-dependencies $GECKO_PATH &&
            ln -s $MOZ_FETCHES_DIR/android-sdk-linux $GECKO_PATH &&
            ln -s $MOZ_FETCHES_DIR/node $GECKO_PATH &&
            cd $GECKO_PATH &&
            ./mach --log-no-times build pre-export export &&
            ./mach --log-no-times lint -f treeherder -f json:/builds/worker/mozlint.json
            --linter android-api-lint
            --linter android-format
            --linter android-javadoc
            --linter android-checkstyle
            --linter android-lint
            --linter android-test
            *
    when:
        files-changed:
            # Source files.
            - 'mobile/android/**/*.java'
            - 'mobile/android/**/*.kt'
            # Resources.
            - 'mobile/android/**/*.jpeg'
            - 'mobile/android/**/*.jpg'
            - 'mobile/android/**/*.png'
            - 'mobile/android/**/*.svg'
            - 'mobile/android/**/*.xml'
            # Build stuff.
            - 'mobile/android/**/Makefile.in'
            - 'mobile/android/config/**'
            - 'mobile/android/gradle.configure'
            - 'mobile/android/**/moz.build'
            - '**/*.gradle'
            # Other misc lint related files.
            - 'python/mozlint/**'
            - 'tools/lint/**'

fenix:
    treeherder:
        symbol: A(fenix-lints)
    run:
        command: >
            ln -s $MOZ_FETCHES_DIR/android-gradle-dependencies $GECKO_PATH &&
            ln -s $MOZ_FETCHES_DIR/android-sdk-linux $GECKO_PATH &&
            ln -s $MOZ_FETCHES_DIR/node $GECKO_PATH &&
            cd $GECKO_PATH &&
            ./mach --log-no-times build pre-export export &&
            ./mach --log-no-times lint -f treeherder -f json:/builds/worker/mozlint.json
            --linter android-fenix
            *
    when:
        files-changed:
            # Source files.
            - 'mobile/android/fenix/**'
            # Build stuff.
            - 'mobile/android/**/Makefile.in'
            - 'mobile/android/config/**'
            - 'mobile/android/gradle.configure'
            - 'mobile/android/**/moz.build'
            - '**/*.gradle'
            # Other misc lint related files.
            - 'python/mozlint/**'
            - 'tools/lint/**'

focus:
    treeherder:
        symbol: A(focus-lints)
    run:
        command: >
            ln -s $MOZ_FETCHES_DIR/android-gradle-dependencies $GECKO_PATH &&
            ln -s $MOZ_FETCHES_DIR/android-sdk-linux $GECKO_PATH &&
            ln -s $MOZ_FETCHES_DIR/node $GECKO_PATH &&
            cd $GECKO_PATH &&
            ./mach --log-no-times build pre-export export &&
            ./mach --log-no-times lint -f treeherder -f json:/builds/worker/mozlint.json
            --linter android-focus
            *
    when:
        files-changed:
            # Source files.
            - 'mobile/android/focus-android/**'
            # Build stuff.
            - 'mobile/android/**/Makefile.in'
            - 'mobile/android/config/**'
            - 'mobile/android/gradle.configure'
            - 'mobile/android/**/moz.build'
            - '**/*.gradle'
            # Other misc lint related files.
            - 'python/mozlint/**'
            - 'tools/lint/**'

android-components:
    treeherder:
        symbol: A(ac-lints)
    run:
        command: >
            ln -s $MOZ_FETCHES_DIR/android-gradle-dependencies $GECKO_PATH &&
            ln -s $MOZ_FETCHES_DIR/android-sdk-linux $GECKO_PATH &&
            ln -s $MOZ_FETCHES_DIR/node $GECKO_PATH &&
            cd $GECKO_PATH &&
            ./mach --log-no-times build pre-export export &&
            ./mach --log-no-times lint -f treeherder -f json:/builds/worker/mozlint.json
            --linter android-ac
            *
    when:
        files-changed:
            # Source files.
            - 'mobile/android/android-components/**'
            # Build stuff.
            - 'mobile/android/**/Makefile.in'
            - 'mobile/android/config/**'
            - 'mobile/android/gradle.configure'
            - 'mobile/android/**/moz.build'
            - '**/*.gradle'
            # Other misc lint related files.
            - 'python/mozlint/**'
            - 'tools/lint/**'
